from _typeshed import Incomplete
from collections.abc import Container
from strictyaml import constants as constants, utils as utils
from strictyaml.exceptions import YAMLSerializationError as YAMLSerializationError
from strictyaml.representation import YAML as YAML
from strictyaml.ruamel.scalarstring import (
    PreservedScalarString as PreservedScalarString,
)
from strictyaml.validators import Validator as Validator
from typing import Optional as _Optional

unicode = str

class ScalarValidator(Validator):
    @property
    def rule_description(self): ...
    def __call__(self, chunk): ...
    def validate(self, chunk): ...
    def should_be_string(self, data, message) -> None: ...
    def validate_scalar(self, chunk) -> None: ...

class Enum(ScalarValidator):
    def __init__(
        self,
        restricted_to: Container[object],
        item_validator: _Optional[Validator] = ...,
    ) -> None: ...
    def validate_scalar(self, chunk): ...
    def to_yaml(self, data): ...

class CommaSeparated(ScalarValidator):
    def __init__(self, item_validator) -> None: ...
    def validate_scalar(self, chunk): ...
    def to_yaml(self, data): ...

class Regex(ScalarValidator):
    def __init__(self, regular_expression) -> None: ...
    def validate_scalar(self, chunk): ...
    def to_yaml(self, data): ...

class Email(Regex):
    def __init__(self) -> None: ...

class Url(ScalarValidator):
    def validate_scalar(self, chunk): ...
    def to_yaml(self, data): ...

class Str(ScalarValidator):
    def validate_scalar(self, chunk): ...
    def to_yaml(self, data): ...

class Int(ScalarValidator):
    def validate_scalar(self, chunk): ...
    def to_yaml(self, data): ...

class HexInt(ScalarValidator):
    def validate_scalar(self, chunk): ...
    def to_yaml(self, data): ...

class Bool(ScalarValidator):
    def validate_scalar(self, chunk): ...
    def to_yaml(self, data): ...

class Float(ScalarValidator):
    def validate_scalar(self, chunk): ...
    def to_yaml(self, data): ...

class Decimal(ScalarValidator):
    def validate_scalar(self, chunk): ...

class Datetime(ScalarValidator):
    def validate_scalar(self, chunk): ...
    def to_yaml(self, data): ...

class NullNone(ScalarValidator):
    def validate_scalar(self, chunk): ...
    def empty(self, chunk) -> None: ...
    def to_yaml(self, data): ...

class EmptyNone(ScalarValidator):
    def validate_scalar(self, chunk): ...
    def empty(self, chunk) -> None: ...
    def to_yaml(self, data): ...

class EmptyDict(EmptyNone):
    def empty(self, chunk): ...
    def to_yaml(self, data): ...

class EmptyList(EmptyNone):
    def empty(self, chunk): ...
    def to_yaml(self, data): ...
